#include <stdio.h>

int lunghezza (char *s)
{
	int i = 0;
	while (*s != '\0') {
		s++;
		i++;
	}
	return i;
}

int verifica_palindroma_ric (char *s, int l)
{
	if (l < 2)
		return 1;
	if (s[0] != s[l-1])
		return 0;

	return verifica_palindroma_ric(s+1, l-2);
}

int verifica_palindroma (char *s)
{
	int i = 0;
	int len = lunghezza(s);
	int j = len-1;

	while (i < j) {
		if (s[i] != s[j])
			return 0;
		i++;
		j--;
	}

	return 1;
}


int main (int argc, char *argv[]) {
	if (argc != 2) {
		printf("Istruzioni: %s <parola>\n", argv[0]);
		return 1;
	}

	char *stringa = argv[1];
	int palindroma = verifica_palindroma(stringa);
	int palindroma2 = verifica_palindroma_ric(stringa, lunghezza(stringa));

	printf("%d\n%d\n", palindroma, palindroma2);

	return 0;
}
